<?php

class MnglProfilesController
{
  function MnglProfilesController()
  {
    add_filter('mngl-activity-types', array( $this, 'add_activity_types' ));
  }
  
  function add_activity_types($activity_types)
  {
    $activity_types['profile_updates'] = array( 'name'    => 'Profile Updates',
                                                'message' => __('%1$s updated %2$s profile', 'mingle') . '|$owner->first_name, $owner->his_her',
                                                'icon'    => MNGL_URL . "/images/smiley.png" );
    return $activity_types;
  }
  
  function directory($dir_page,$user_search=false,$search_query='',$dir_page_size=25)
  {
    // Reset to page 1 if a search term is entered
    if(!empty($search_query))
      $dir_page = '';
    
    $dir_page = (empty($dir_page)?0:($dir_page-1));
    $dir_offset = $dir_page * $dir_page_size;
    $profiles = MnglUser::get_stored_profiles($search_query,$dir_offset,$dir_page_size);
    
    $search_where = '';

    if(!empty($search_query))
      $search_where = "user_nicename like '%{$search_query}%'";

    $num_pages = MnglUser::get_count($search_where) / $dir_page_size;
    
    $prev_page = $dir_page;
    $next_page = ((($dir_page+1) >= $num_pages)?0:($dir_page + 2));
    require_once MNGL_VIEWS_PATH . "/mngl-profiles/directory.php";
  }

  function profile()
  {
    global $friends_controller, $boards_controller, $app_helper, $mngl_blogurl;

    if(is_user_logged_in() and !isset($_GET['u']))
    {
      $user = MnglUser::get_stored_profile();
      $avatar_url = $user->get_avatar_url();
      $avatar_dimensions = $user->get_avatar_dimensions(200);
      require_once MNGL_VIEWS_PATH . "/mngl-profiles/profile.php";
    }
    else if(isset($_GET['u']))
    {
      $screenname = $_GET['u'];
      $user = MnglUser::get_stored_profile_by_screenname($screenname);
      $avatar_url = $user->get_avatar_url();
      $avatar_dimensions = $user->get_avatar_dimensions(200);
      require_once MNGL_VIEWS_PATH . "/mngl-profiles/profile.php";
    }
    else
      require_once MNGL_VIEWS_PATH . "/shared/unauthorized.php";
  }
  
  function activity()
  {
    global $friends_controller, $boards_controller, $app_helper, $mngl_blogurl;

    if(is_user_logged_in())
    {
      $user = MnglUser::get_stored_profile();
      require_once MNGL_VIEWS_PATH . "/mngl-profiles/activity.php";
    }
    else
      require_once MNGL_VIEWS_PATH . "/shared/unauthorized.php";
  }

  function edit()
  {
    if(is_user_logged_in())
    {
      global $mngl_user, $mngl_blogurl, $mngl_board_post;
      
      $avatar_url = $mngl_user->get_avatar_url('thumb');
      $avatar_dim = $mngl_user->get_avatar_dimensions(100);
      
      if(isset($_POST['action']) and $_POST['action'] == 'process_form')
      {
        $errors = apply_filters('mngl-profile-validate',$mngl_user->validate($_POST,array()));
        
        if(count($errors) <= 0)
        {
          $mngl_user->update($_POST);
          $mngl_user->store();

          $avatar_url = $mngl_user->get_avatar_url('thumb');
          $avatar_dim = $mngl_user->get_avatar_dimensions(100);
        
          do_action('mngl-profile-update');

          $mngl_board_post->add_activity_by_id( $mngl_user->id, $mngl_user->id, 'profile_updates' );

          require_once MNGL_VIEWS_PATH . "/mngl-profiles/profile_saved.php";
        }
        else
          require_once MNGL_VIEWS_PATH . "/shared/errors.php";
      }
      
      require_once MNGL_VIEWS_PATH . "/mngl-profiles/edit.php";
    }
    else
      require_once MNGL_VIEWS_PATH . "/shared/unauthorized.php";
  }
  
  function display_status($user_id)
  {
    global $app_helper;
    
    $user = MnglUser::get_stored_profile_by_id($user_id);
    
    require_once MNGL_VIEWS_PATH . "/mngl-profiles/profile_status.php";
  }
  
  function delete_avatar($user_id)
  {
    global $mngl_user;
    
    if(is_user_logged_in() and $user_id==$mngl_user->id)
    {
      $mngl_user->avatar = '';
      $mngl_user->avatar_meta = '';
      $mngl_user->avatar_thumb = '';
      $mngl_user->avatar_thumb_meta = '';
      $mngl_user->store();
      
      $avatar_url = $mngl_user->get_avatar_url('thumb');
      $avatar_dim = $mngl_user->get_avatar_dimensions(100);
      require_once MNGL_VIEWS_PATH . "/mngl-profiles/edit_avatar.php";
    }
  }
}
?>
